/* key-event.c generated by valac 0.56.3, the Vala compiler
 * generated from key-event.vala, do not modify */

/*
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libkkc/libkkc.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

enum  {
	KKC_KEY_EVENT_0_PROPERTY,
	KKC_KEY_EVENT_NAME_PROPERTY,
	KKC_KEY_EVENT_UNICODE_PROPERTY,
	KKC_KEY_EVENT_KEYVAL_PROPERTY,
	KKC_KEY_EVENT_KEYCODE_PROPERTY,
	KKC_KEY_EVENT_MODIFIERS_PROPERTY,
	KKC_KEY_EVENT_NUM_PROPERTIES
};
static GParamSpec* kkc_key_event_properties[KKC_KEY_EVENT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _KkcKeyEventPrivate {
	gchar* _name;
	gunichar _unicode;
	guint _keyval;
	guint _keycode;
	KkcModifierType _modifiers;
};

static gint KkcKeyEvent_private_offset;
static gpointer kkc_key_event_parent_class = NULL;

VALA_EXTERN guint kkc_key_event_utils_keyval_from_name (const gchar* name);
VALA_EXTERN gchar* kkc_key_event_utils_keyval_name (guint keyval);
VALA_EXTERN gunichar kkc_key_event_utils_keyval_unicode (guint keyval);
static void kkc_key_event_finalize (GObject * obj);
static GType kkc_key_event_get_type_once (void);
static void _vala_kkc_key_event_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_kkc_key_event_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

GQuark
kkc_key_event_format_error_quark (void)
{
	return g_quark_from_static_string ("kkc-key-event-format-error-quark");
}

static GType
kkc_key_event_format_error_get_type_once (void)
{
	static const GEnumValue values[] = {{KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED", "parse-failed"}, {KKC_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND, "KKC_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND", "keysym-not-found"}, {0, NULL, NULL}};
	GType kkc_key_event_format_error_type_id;
	kkc_key_event_format_error_type_id = g_enum_register_static ("KkcKeyEventFormatError", values);
	return kkc_key_event_format_error_type_id;
}

GType
kkc_key_event_format_error_get_type (void)
{
	static volatile gsize kkc_key_event_format_error_type_id__once = 0;
	if (g_once_init_enter (&kkc_key_event_format_error_type_id__once)) {
		GType kkc_key_event_format_error_type_id;
		kkc_key_event_format_error_type_id = kkc_key_event_format_error_get_type_once ();
		g_once_init_leave (&kkc_key_event_format_error_type_id__once, kkc_key_event_format_error_type_id);
	}
	return kkc_key_event_format_error_type_id__once;
}

/**
     * A set of bit-flags to indicate the state of modifier keys.
     */
static GType
kkc_modifier_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{KKC_MODIFIER_TYPE_NONE, "KKC_MODIFIER_TYPE_NONE", "none"}, {KKC_MODIFIER_TYPE_SHIFT_MASK, "KKC_MODIFIER_TYPE_SHIFT_MASK", "shift-mask"}, {KKC_MODIFIER_TYPE_LOCK_MASK, "KKC_MODIFIER_TYPE_LOCK_MASK", "lock-mask"}, {KKC_MODIFIER_TYPE_CONTROL_MASK, "KKC_MODIFIER_TYPE_CONTROL_MASK", "control-mask"}, {KKC_MODIFIER_TYPE_MOD1_MASK, "KKC_MODIFIER_TYPE_MOD1_MASK", "mod1-mask"}, {KKC_MODIFIER_TYPE_MOD2_MASK, "KKC_MODIFIER_TYPE_MOD2_MASK", "mod2-mask"}, {KKC_MODIFIER_TYPE_MOD3_MASK, "KKC_MODIFIER_TYPE_MOD3_MASK", "mod3-mask"}, {KKC_MODIFIER_TYPE_MOD4_MASK, "KKC_MODIFIER_TYPE_MOD4_MASK", "mod4-mask"}, {KKC_MODIFIER_TYPE_MOD5_MASK, "KKC_MODIFIER_TYPE_MOD5_MASK", "mod5-mask"}, {KKC_MODIFIER_TYPE_LSHIFT_MASK, "KKC_MODIFIER_TYPE_LSHIFT_MASK", "lshift-mask"}, {KKC_MODIFIER_TYPE_RSHIFT_MASK, "KKC_MODIFIER_TYPE_RSHIFT_MASK", "rshift-mask"}, {KKC_MODIFIER_TYPE_SUPER_MASK, "KKC_MODIFIER_TYPE_SUPER_MASK", "super-mask"}, {KKC_MODIFIER_TYPE_HYPER_MASK, "KKC_MODIFIER_TYPE_HYPER_MASK", "hyper-mask"}, {KKC_MODIFIER_TYPE_META_MASK, "KKC_MODIFIER_TYPE_META_MASK", "meta-mask"}, {KKC_MODIFIER_TYPE_RELEASE_MASK, "KKC_MODIFIER_TYPE_RELEASE_MASK", "release-mask"}, {0, NULL, NULL}};
	GType kkc_modifier_type_type_id;
	kkc_modifier_type_type_id = g_flags_register_static ("KkcModifierType", values);
	return kkc_modifier_type_type_id;
}

GType
kkc_modifier_type_get_type (void)
{
	static volatile gsize kkc_modifier_type_type_id__once = 0;
	if (g_once_init_enter (&kkc_modifier_type_type_id__once)) {
		GType kkc_modifier_type_type_id;
		kkc_modifier_type_type_id = kkc_modifier_type_get_type_once ();
		g_once_init_leave (&kkc_modifier_type_type_id__once, kkc_modifier_type_type_id);
	}
	return kkc_modifier_type_type_id__once;
}

static inline gpointer
kkc_key_event_get_instance_private (KkcKeyEvent* self)
{
	return G_STRUCT_MEMBER_P (self, KkcKeyEvent_private_offset);
}

/**
         * Create a key event from string.
         *
         * @param key a string representation of a key event
         *
         * @return a new KeyEvent
         */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 163 "key-event.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 169 "key-event.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 175 "key-event.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 179 "key-event.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 187 "key-event.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 191 "key-event.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 203 "key-event.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1152 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1152 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1154 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1154 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 227 "key-event.c"
		gchar* _tmp2_;
#line 1155 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1155 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1155 "glib-2.0.vapi"
		return result;
#line 235 "key-event.c"
	} else {
#line 1157 "glib-2.0.vapi"
		result = -1;
#line 1157 "glib-2.0.vapi"
		return result;
#line 241 "key-event.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 265 "key-event.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 274 "key-event.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 293 "key-event.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 297 "key-event.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 303 "key-event.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 313 "key-event.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 321 "key-event.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 325 "key-event.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 331 "key-event.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 341 "key-event.c"
}

KkcKeyEvent*
kkc_key_event_construct_from_string (GType object_type,
                                     const gchar* key,
                                     GError** error)
{
	KkcKeyEvent * self = NULL;
	KkcModifierType _modifiers = 0U;
	guint _keyval = 0U;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 87 "key-event.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 88 "key-event.vala"
	_modifiers = 0;
#line 89 "key-event.vala"
	_keyval = KKC_KEYSYMS_VoidSymbol;
#line 90 "key-event.vala"
	if (g_str_has_prefix (key, "(")) {
#line 90 "key-event.vala"
		_tmp0_ = g_str_has_suffix (key, ")");
#line 364 "key-event.c"
	} else {
#line 90 "key-event.vala"
		_tmp0_ = FALSE;
#line 368 "key-event.c"
	}
#line 90 "key-event.vala"
	if (_tmp0_) {
#line 372 "key-event.c"
		gchar** strv = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gint strv_length1;
		gint _strv_size_;
		gint index = 0;
		gchar** _tmp30_;
		gint _tmp30__length1;
		const gchar* _tmp31_;
#line 91 "key-event.vala"
		_tmp1_ = string_slice (key, (glong) 1, (glong) -1);
#line 91 "key-event.vala"
		_tmp2_ = _tmp1_;
#line 91 "key-event.vala"
		_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, " ", 0);
#line 91 "key-event.vala"
		_tmp5_ = _tmp4_;
#line 91 "key-event.vala"
		_tmp5__length1 = _vala_array_length (_tmp3_);
#line 91 "key-event.vala"
		_g_free0 (_tmp2_);
#line 91 "key-event.vala"
		strv = _tmp5_;
#line 91 "key-event.vala"
		strv_length1 = _tmp5__length1;
#line 91 "key-event.vala"
		_strv_size_ = strv_length1;
#line 92 "key-event.vala"
		index = 0;
#line 406 "key-event.c"
		{
			gboolean _tmp6_ = FALSE;
#line 93 "key-event.vala"
			_tmp6_ = TRUE;
#line 93 "key-event.vala"
			while (TRUE) {
#line 413 "key-event.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
#line 93 "key-event.vala"
				if (!_tmp6_) {
#line 421 "key-event.c"
					gint _tmp7_;
#line 93 "key-event.vala"
					_tmp7_ = index;
#line 93 "key-event.vala"
					index = _tmp7_ + 1;
#line 427 "key-event.c"
				}
#line 93 "key-event.vala"
				_tmp6_ = FALSE;
#line 93 "key-event.vala"
				_tmp8_ = strv;
#line 93 "key-event.vala"
				_tmp8__length1 = strv_length1;
#line 93 "key-event.vala"
				if (!(index < (_tmp8__length1 - 1))) {
#line 93 "key-event.vala"
					break;
#line 439 "key-event.c"
				}
#line 94 "key-event.vala"
				_tmp9_ = strv;
#line 94 "key-event.vala"
				_tmp9__length1 = strv_length1;
#line 94 "key-event.vala"
				_tmp10_ = _tmp9_[index];
#line 94 "key-event.vala"
				if (g_strcmp0 (_tmp10_, "shift") == 0) {
#line 95 "key-event.vala"
					_modifiers |= KKC_MODIFIER_TYPE_SHIFT_MASK;
#line 451 "key-event.c"
				} else {
					gchar** _tmp11_;
					gint _tmp11__length1;
					const gchar* _tmp12_;
#line 96 "key-event.vala"
					_tmp11_ = strv;
#line 96 "key-event.vala"
					_tmp11__length1 = strv_length1;
#line 96 "key-event.vala"
					_tmp12_ = _tmp11_[index];
#line 96 "key-event.vala"
					if (g_strcmp0 (_tmp12_, "control") == 0) {
#line 97 "key-event.vala"
						_modifiers |= KKC_MODIFIER_TYPE_CONTROL_MASK;
#line 466 "key-event.c"
					} else {
						gchar** _tmp13_;
						gint _tmp13__length1;
						const gchar* _tmp14_;
#line 98 "key-event.vala"
						_tmp13_ = strv;
#line 98 "key-event.vala"
						_tmp13__length1 = strv_length1;
#line 98 "key-event.vala"
						_tmp14_ = _tmp13_[index];
#line 98 "key-event.vala"
						if (g_strcmp0 (_tmp14_, "meta") == 0) {
#line 99 "key-event.vala"
							_modifiers |= KKC_MODIFIER_TYPE_META_MASK;
#line 481 "key-event.c"
						} else {
							gchar** _tmp15_;
							gint _tmp15__length1;
							const gchar* _tmp16_;
#line 100 "key-event.vala"
							_tmp15_ = strv;
#line 100 "key-event.vala"
							_tmp15__length1 = strv_length1;
#line 100 "key-event.vala"
							_tmp16_ = _tmp15_[index];
#line 100 "key-event.vala"
							if (g_strcmp0 (_tmp16_, "hyper") == 0) {
#line 101 "key-event.vala"
								_modifiers |= KKC_MODIFIER_TYPE_HYPER_MASK;
#line 496 "key-event.c"
							} else {
								gchar** _tmp17_;
								gint _tmp17__length1;
								const gchar* _tmp18_;
#line 102 "key-event.vala"
								_tmp17_ = strv;
#line 102 "key-event.vala"
								_tmp17__length1 = strv_length1;
#line 102 "key-event.vala"
								_tmp18_ = _tmp17_[index];
#line 102 "key-event.vala"
								if (g_strcmp0 (_tmp18_, "super") == 0) {
#line 103 "key-event.vala"
									_modifiers |= KKC_MODIFIER_TYPE_SUPER_MASK;
#line 511 "key-event.c"
								} else {
									gchar** _tmp19_;
									gint _tmp19__length1;
									const gchar* _tmp20_;
#line 104 "key-event.vala"
									_tmp19_ = strv;
#line 104 "key-event.vala"
									_tmp19__length1 = strv_length1;
#line 104 "key-event.vala"
									_tmp20_ = _tmp19_[index];
#line 104 "key-event.vala"
									if (g_strcmp0 (_tmp20_, "alt") == 0) {
#line 105 "key-event.vala"
										_modifiers |= KKC_MODIFIER_TYPE_MOD1_MASK;
#line 526 "key-event.c"
									} else {
										gchar** _tmp21_;
										gint _tmp21__length1;
										const gchar* _tmp22_;
#line 106 "key-event.vala"
										_tmp21_ = strv;
#line 106 "key-event.vala"
										_tmp21__length1 = strv_length1;
#line 106 "key-event.vala"
										_tmp22_ = _tmp21_[index];
#line 106 "key-event.vala"
										if (g_strcmp0 (_tmp22_, "lshift") == 0) {
#line 107 "key-event.vala"
											_modifiers |= KKC_MODIFIER_TYPE_LSHIFT_MASK;
#line 541 "key-event.c"
										} else {
											gchar** _tmp23_;
											gint _tmp23__length1;
											const gchar* _tmp24_;
#line 108 "key-event.vala"
											_tmp23_ = strv;
#line 108 "key-event.vala"
											_tmp23__length1 = strv_length1;
#line 108 "key-event.vala"
											_tmp24_ = _tmp23_[index];
#line 108 "key-event.vala"
											if (g_strcmp0 (_tmp24_, "rshift") == 0) {
#line 109 "key-event.vala"
												_modifiers |= KKC_MODIFIER_TYPE_RSHIFT_MASK;
#line 556 "key-event.c"
											} else {
												gchar** _tmp25_;
												gint _tmp25__length1;
												const gchar* _tmp26_;
#line 110 "key-event.vala"
												_tmp25_ = strv;
#line 110 "key-event.vala"
												_tmp25__length1 = strv_length1;
#line 110 "key-event.vala"
												_tmp26_ = _tmp25_[index];
#line 110 "key-event.vala"
												if (g_strcmp0 (_tmp26_, "release") == 0) {
#line 111 "key-event.vala"
													_modifiers |= KKC_MODIFIER_TYPE_RELEASE_MASK;
#line 571 "key-event.c"
												} else {
													gchar** _tmp27_;
													gint _tmp27__length1;
													const gchar* _tmp28_;
													GError* _tmp29_;
#line 113 "key-event.vala"
													_tmp27_ = strv;
#line 113 "key-event.vala"
													_tmp27__length1 = strv_length1;
#line 113 "key-event.vala"
													_tmp28_ = _tmp27_[index];
#line 113 "key-event.vala"
													_tmp29_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown modifier %s", _tmp28_);
#line 113 "key-event.vala"
													_inner_error0_ = _tmp29_;
#line 113 "key-event.vala"
													if (_inner_error0_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
#line 113 "key-event.vala"
														g_propagate_error (error, _inner_error0_);
#line 113 "key-event.vala"
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 113 "key-event.vala"
														_g_object_unref0 (self);
#line 113 "key-event.vala"
														return NULL;
#line 597 "key-event.c"
													} else {
#line 113 "key-event.vala"
														strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 113 "key-event.vala"
														g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "key-event.vala"
														g_clear_error (&_inner_error0_);
#line 113 "key-event.vala"
														return NULL;
#line 607 "key-event.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
#line 117 "key-event.vala"
		_tmp30_ = strv;
#line 117 "key-event.vala"
		_tmp30__length1 = strv_length1;
#line 117 "key-event.vala"
		_tmp31_ = _tmp30_[index];
#line 117 "key-event.vala"
		_keyval = kkc_key_event_utils_keyval_from_name (_tmp31_);
#line 118 "key-event.vala"
		if (_keyval == KKC_KEYSYMS_VoidSymbol) {
#line 630 "key-event.c"
			gchar** _tmp32_;
			gint _tmp32__length1;
			const gchar* _tmp33_;
			GError* _tmp34_;
#line 119 "key-event.vala"
			_tmp32_ = strv;
#line 119 "key-event.vala"
			_tmp32__length1 = strv_length1;
#line 119 "key-event.vala"
			_tmp33_ = _tmp32_[index];
#line 119 "key-event.vala"
			_tmp34_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown keyval %s", _tmp33_);
#line 119 "key-event.vala"
			_inner_error0_ = _tmp34_;
#line 119 "key-event.vala"
			if (_inner_error0_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
#line 119 "key-event.vala"
				g_propagate_error (error, _inner_error0_);
#line 119 "key-event.vala"
				strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 119 "key-event.vala"
				_g_object_unref0 (self);
#line 119 "key-event.vala"
				return NULL;
#line 655 "key-event.c"
			} else {
#line 119 "key-event.vala"
				strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 119 "key-event.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 119 "key-event.vala"
				g_clear_error (&_inner_error0_);
#line 119 "key-event.vala"
				return NULL;
#line 665 "key-event.c"
			}
		}
#line 90 "key-event.vala"
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 670 "key-event.c"
	} else {
		gint index = 0;
		gchar* _name = NULL;
		const gchar* _tmp49_;
#line 123 "key-event.vala"
		index = string_last_index_of (key, "-", 0);
#line 124 "key-event.vala"
		_name = NULL;
#line 125 "key-event.vala"
		if (index > 0) {
#line 681 "key-event.c"
			gchar** mods = NULL;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar** _tmp37_;
			gchar** _tmp38_;
			gchar** _tmp39_;
			gint _tmp39__length1;
			gint mods_length1;
			gint _mods_size_;
			gchar** _tmp40_;
			gint _tmp40__length1;
			gchar* _tmp47_;
#line 127 "key-event.vala"
			_tmp35_ = string_substring (key, (glong) 0, (glong) index);
#line 127 "key-event.vala"
			_tmp36_ = _tmp35_;
#line 127 "key-event.vala"
			_tmp38_ = _tmp37_ = g_strsplit (_tmp36_, "-", 0);
#line 127 "key-event.vala"
			_tmp39_ = _tmp38_;
#line 127 "key-event.vala"
			_tmp39__length1 = _vala_array_length (_tmp37_);
#line 127 "key-event.vala"
			_g_free0 (_tmp36_);
#line 127 "key-event.vala"
			mods = _tmp39_;
#line 127 "key-event.vala"
			mods_length1 = _tmp39__length1;
#line 127 "key-event.vala"
			_mods_size_ = mods_length1;
#line 128 "key-event.vala"
			_tmp40_ = mods;
#line 128 "key-event.vala"
			_tmp40__length1 = mods_length1;
#line 716 "key-event.c"
			{
				gchar** mod_collection = NULL;
				gint mod_collection_length1 = 0;
				gint _mod_collection_size_ = 0;
				gint mod_it = 0;
#line 128 "key-event.vala"
				mod_collection = _tmp40_;
#line 128 "key-event.vala"
				mod_collection_length1 = _tmp40__length1;
#line 128 "key-event.vala"
				for (mod_it = 0; mod_it < mod_collection_length1; mod_it = mod_it + 1) {
#line 728 "key-event.c"
					gchar* _tmp41_;
					gchar* mod = NULL;
#line 128 "key-event.vala"
					_tmp41_ = g_strdup (mod_collection[mod_it]);
#line 128 "key-event.vala"
					mod = _tmp41_;
#line 735 "key-event.c"
					{
						const gchar* _tmp42_;
#line 129 "key-event.vala"
						_tmp42_ = mod;
#line 129 "key-event.vala"
						if (g_strcmp0 (_tmp42_, "S") == 0) {
#line 130 "key-event.vala"
							_modifiers |= KKC_MODIFIER_TYPE_SHIFT_MASK;
#line 744 "key-event.c"
						} else {
							const gchar* _tmp43_;
#line 131 "key-event.vala"
							_tmp43_ = mod;
#line 131 "key-event.vala"
							if (g_strcmp0 (_tmp43_, "C") == 0) {
#line 132 "key-event.vala"
								_modifiers |= KKC_MODIFIER_TYPE_CONTROL_MASK;
#line 753 "key-event.c"
							} else {
								const gchar* _tmp44_;
#line 133 "key-event.vala"
								_tmp44_ = mod;
#line 133 "key-event.vala"
								if (g_strcmp0 (_tmp44_, "A") == 0) {
#line 134 "key-event.vala"
									_modifiers |= KKC_MODIFIER_TYPE_MOD1_MASK;
#line 762 "key-event.c"
								} else {
									const gchar* _tmp45_;
#line 135 "key-event.vala"
									_tmp45_ = mod;
#line 135 "key-event.vala"
									if (g_strcmp0 (_tmp45_, "M") == 0) {
#line 136 "key-event.vala"
										_modifiers |= KKC_MODIFIER_TYPE_META_MASK;
#line 771 "key-event.c"
									} else {
										const gchar* _tmp46_;
#line 137 "key-event.vala"
										_tmp46_ = mod;
#line 137 "key-event.vala"
										if (g_strcmp0 (_tmp46_, "G") == 0) {
#line 138 "key-event.vala"
											_modifiers |= KKC_MODIFIER_TYPE_MOD5_MASK;
#line 780 "key-event.c"
										}
									}
								}
							}
						}
#line 128 "key-event.vala"
						_g_free0 (mod);
#line 788 "key-event.c"
					}
				}
			}
#line 141 "key-event.vala"
			_tmp47_ = string_substring (key, (glong) (index + 1), (glong) -1);
#line 141 "key-event.vala"
			_g_free0 (_name);
#line 141 "key-event.vala"
			_name = _tmp47_;
#line 125 "key-event.vala"
			mods = (_vala_array_free (mods, mods_length1, (GDestroyNotify) g_free), NULL);
#line 800 "key-event.c"
		} else {
			gchar* _tmp48_;
#line 143 "key-event.vala"
			_modifiers = KKC_MODIFIER_TYPE_NONE;
#line 144 "key-event.vala"
			_tmp48_ = g_strdup (key);
#line 144 "key-event.vala"
			_g_free0 (_name);
#line 144 "key-event.vala"
			_name = _tmp48_;
#line 811 "key-event.c"
		}
#line 146 "key-event.vala"
		_tmp49_ = _name;
#line 146 "key-event.vala"
		_keyval = kkc_key_event_utils_keyval_from_name (_tmp49_);
#line 147 "key-event.vala"
		if (_keyval == KKC_KEYSYMS_VoidSymbol) {
#line 819 "key-event.c"
			const gchar* _tmp50_;
			GError* _tmp51_;
#line 148 "key-event.vala"
			_tmp50_ = _name;
#line 148 "key-event.vala"
			_tmp51_ = g_error_new (KKC_KEY_EVENT_FORMAT_ERROR, KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED, "unknown keyval %s", _tmp50_);
#line 148 "key-event.vala"
			_inner_error0_ = _tmp51_;
#line 148 "key-event.vala"
			if (_inner_error0_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
#line 148 "key-event.vala"
				g_propagate_error (error, _inner_error0_);
#line 148 "key-event.vala"
				_g_free0 (_name);
#line 148 "key-event.vala"
				_g_object_unref0 (self);
#line 148 "key-event.vala"
				return NULL;
#line 838 "key-event.c"
			} else {
#line 148 "key-event.vala"
				_g_free0 (_name);
#line 148 "key-event.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "key-event.vala"
				g_clear_error (&_inner_error0_);
#line 148 "key-event.vala"
				return NULL;
#line 848 "key-event.c"
			}
		}
#line 90 "key-event.vala"
		_g_free0 (_name);
#line 853 "key-event.c"
	}
#line 151 "key-event.vala"
	self = (KkcKeyEvent*) kkc_key_event_construct_from_x_event (object_type, _keyval, (guint) 0, _modifiers);
#line 87 "key-event.vala"
	return self;
#line 859 "key-event.c"
}

KkcKeyEvent*
kkc_key_event_new_from_string (const gchar* key,
                               GError** error)
{
#line 87 "key-event.vala"
	return kkc_key_event_construct_from_string (KKC_TYPE_KEY_EVENT, key, error);
#line 868 "key-event.c"
}

/**
         * Convert the KeyEvent to string.
         *
         * @return a string representing the KeyEvent
         */
static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1079 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1079 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1080 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1081 "glib-2.0.vapi"
	result = str;
#line 1081 "glib-2.0.vapi"
	return result;
#line 892 "key-event.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 906 "key-event.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 910 "key-event.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 916 "key-event.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 921 "key-event.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 927 "key-event.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 931 "key-event.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 935 "key-event.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 939 "key-event.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 943 "key-event.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 947 "key-event.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 962 "key-event.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 971 "key-event.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 978 "key-event.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 984 "key-event.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 992 "key-event.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 996 "key-event.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1002 "key-event.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1007 "key-event.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1013 "key-event.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1017 "key-event.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1021 "key-event.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 1027 "key-event.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1033 "key-event.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1045 "key-event.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1049 "key-event.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1053 "key-event.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 1058 "key-event.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 1066 "key-event.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1084 "key-event.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1090 "key-event.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1094 "key-event.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1102 "key-event.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1111 "key-event.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1120 "key-event.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1126 "key-event.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1134 "key-event.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1146 "key-event.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1152 "key-event.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1156 "key-event.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1164 "key-event.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1175 "key-event.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1184 "key-event.c"
	}
}

gchar*
kkc_key_event_to_string (KkcKeyEvent* self)
{
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _base = NULL;
	gchar* _tmp6_;
	KkcModifierType _tmp7_;
	gchar* result;
#line 159 "key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "key-event.vala"
	_tmp1_ = self->priv->_name;
#line 160 "key-event.vala"
	if (_tmp1_ != NULL) {
#line 1203 "key-event.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 160 "key-event.vala"
		_tmp2_ = self->priv->_name;
#line 160 "key-event.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 160 "key-event.vala"
		_g_free0 (_tmp0_);
#line 160 "key-event.vala"
		_tmp0_ = _tmp3_;
#line 1214 "key-event.c"
	} else {
		gunichar _tmp4_;
		gchar* _tmp5_;
#line 160 "key-event.vala"
		_tmp4_ = self->priv->_unicode;
#line 160 "key-event.vala"
		_tmp5_ = g_unichar_to_string (_tmp4_);
#line 160 "key-event.vala"
		_g_free0 (_tmp0_);
#line 160 "key-event.vala"
		_tmp0_ = _tmp5_;
#line 1226 "key-event.c"
	}
#line 160 "key-event.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 160 "key-event.vala"
	_base = _tmp6_;
#line 161 "key-event.vala"
	_tmp7_ = self->priv->_modifiers;
#line 161 "key-event.vala"
	if (_tmp7_ != 0) {
#line 1236 "key-event.c"
		GeeArrayList* elements = NULL;
		GeeArrayList* _tmp8_;
		KkcModifierType _tmp9_;
		KkcModifierType _tmp11_;
		KkcModifierType _tmp13_;
		KkcModifierType _tmp15_;
		KkcModifierType _tmp17_;
		KkcModifierType _tmp19_;
		KkcModifierType _tmp21_;
		KkcModifierType _tmp23_;
		KkcModifierType _tmp25_;
		GeeArrayList* _tmp27_;
		const gchar* _tmp28_;
		GeeArrayList* _tmp29_;
		gchar** array = NULL;
		GeeArrayList* _tmp30_;
		gint _tmp31_ = 0;
		gpointer* _tmp32_;
		gint array_length1;
		gint _array_size_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
#line 162 "key-event.vala"
		_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 162 "key-event.vala"
		elements = _tmp8_;
#line 163 "key-event.vala"
		_tmp9_ = self->priv->_modifiers;
#line 163 "key-event.vala"
		if ((_tmp9_ & KKC_MODIFIER_TYPE_SHIFT_MASK) != 0) {
#line 1273 "key-event.c"
			GeeArrayList* _tmp10_;
#line 164 "key-event.vala"
			_tmp10_ = elements;
#line 164 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, "shift");
#line 1279 "key-event.c"
		}
#line 166 "key-event.vala"
		_tmp11_ = self->priv->_modifiers;
#line 166 "key-event.vala"
		if ((_tmp11_ & KKC_MODIFIER_TYPE_CONTROL_MASK) != 0) {
#line 1285 "key-event.c"
			GeeArrayList* _tmp12_;
#line 167 "key-event.vala"
			_tmp12_ = elements;
#line 167 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, "control");
#line 1291 "key-event.c"
		}
#line 169 "key-event.vala"
		_tmp13_ = self->priv->_modifiers;
#line 169 "key-event.vala"
		if ((_tmp13_ & KKC_MODIFIER_TYPE_META_MASK) != 0) {
#line 1297 "key-event.c"
			GeeArrayList* _tmp14_;
#line 170 "key-event.vala"
			_tmp14_ = elements;
#line 170 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, "meta");
#line 1303 "key-event.c"
		}
#line 172 "key-event.vala"
		_tmp15_ = self->priv->_modifiers;
#line 172 "key-event.vala"
		if ((_tmp15_ & KKC_MODIFIER_TYPE_HYPER_MASK) != 0) {
#line 1309 "key-event.c"
			GeeArrayList* _tmp16_;
#line 173 "key-event.vala"
			_tmp16_ = elements;
#line 173 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, "hyper");
#line 1315 "key-event.c"
		}
#line 175 "key-event.vala"
		_tmp17_ = self->priv->_modifiers;
#line 175 "key-event.vala"
		if ((_tmp17_ & KKC_MODIFIER_TYPE_SUPER_MASK) != 0) {
#line 1321 "key-event.c"
			GeeArrayList* _tmp18_;
#line 176 "key-event.vala"
			_tmp18_ = elements;
#line 176 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, "super");
#line 1327 "key-event.c"
		}
#line 178 "key-event.vala"
		_tmp19_ = self->priv->_modifiers;
#line 178 "key-event.vala"
		if ((_tmp19_ & KKC_MODIFIER_TYPE_MOD1_MASK) != 0) {
#line 1333 "key-event.c"
			GeeArrayList* _tmp20_;
#line 179 "key-event.vala"
			_tmp20_ = elements;
#line 179 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, "alt");
#line 1339 "key-event.c"
		}
#line 181 "key-event.vala"
		_tmp21_ = self->priv->_modifiers;
#line 181 "key-event.vala"
		if ((_tmp21_ & KKC_MODIFIER_TYPE_LSHIFT_MASK) != 0) {
#line 1345 "key-event.c"
			GeeArrayList* _tmp22_;
#line 182 "key-event.vala"
			_tmp22_ = elements;
#line 182 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, "lshift");
#line 1351 "key-event.c"
		}
#line 184 "key-event.vala"
		_tmp23_ = self->priv->_modifiers;
#line 184 "key-event.vala"
		if ((_tmp23_ & KKC_MODIFIER_TYPE_RSHIFT_MASK) != 0) {
#line 1357 "key-event.c"
			GeeArrayList* _tmp24_;
#line 185 "key-event.vala"
			_tmp24_ = elements;
#line 185 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, "rshift");
#line 1363 "key-event.c"
		}
#line 187 "key-event.vala"
		_tmp25_ = self->priv->_modifiers;
#line 187 "key-event.vala"
		if ((_tmp25_ & KKC_MODIFIER_TYPE_RELEASE_MASK) != 0) {
#line 1369 "key-event.c"
			GeeArrayList* _tmp26_;
#line 188 "key-event.vala"
			_tmp26_ = elements;
#line 188 "key-event.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, "release");
#line 1375 "key-event.c"
		}
#line 190 "key-event.vala"
		_tmp27_ = elements;
#line 190 "key-event.vala"
		_tmp28_ = _base;
#line 190 "key-event.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 191 "key-event.vala"
		_tmp29_ = elements;
#line 191 "key-event.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, NULL);
#line 194 "key-event.vala"
		_tmp30_ = elements;
#line 194 "key-event.vala"
		_tmp32_ = gee_collection_to_array ((GeeCollection*) _tmp30_, &_tmp31_);
#line 194 "key-event.vala"
		array = _tmp32_;
#line 194 "key-event.vala"
		array_length1 = _tmp31_;
#line 194 "key-event.vala"
		_array_size_ = array_length1;
#line 195 "key-event.vala"
		array_length1 = -1;
#line 196 "key-event.vala"
		_tmp33_ = array;
#line 196 "key-event.vala"
		_tmp33__length1 = array_length1;
#line 196 "key-event.vala"
		_tmp34_ = _vala_g_strjoinv (" ", _tmp33_, (gint) _tmp33__length1);
#line 196 "key-event.vala"
		_tmp35_ = _tmp34_;
#line 196 "key-event.vala"
		_tmp36_ = g_strconcat ("(", _tmp35_, NULL);
#line 196 "key-event.vala"
		_tmp37_ = _tmp36_;
#line 196 "key-event.vala"
		_tmp38_ = g_strconcat (_tmp37_, ")", NULL);
#line 196 "key-event.vala"
		_tmp39_ = _tmp38_;
#line 196 "key-event.vala"
		_g_free0 (_tmp37_);
#line 196 "key-event.vala"
		_g_free0 (_tmp35_);
#line 196 "key-event.vala"
		result = _tmp39_;
#line 196 "key-event.vala"
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_free), NULL);
#line 196 "key-event.vala"
		_g_object_unref0 (elements);
#line 196 "key-event.vala"
		_g_free0 (_base);
#line 196 "key-event.vala"
		_g_free0 (_tmp0_);
#line 196 "key-event.vala"
		return result;
#line 1431 "key-event.c"
	} else {
#line 198 "key-event.vala"
		result = _base;
#line 198 "key-event.vala"
		_g_free0 (_tmp0_);
#line 198 "key-event.vala"
		return result;
#line 1439 "key-event.c"
	}
}

KkcKeyEvent*
kkc_key_event_construct_from_x_event (GType object_type,
                                      guint keyval,
                                      guint keycode,
                                      KkcModifierType modifiers)
{
	KkcKeyEvent * self = NULL;
#line 206 "key-event.vala"
	self = (KkcKeyEvent*) kkc_key_event_construct (object_type, keyval, keycode, modifiers);
#line 202 "key-event.vala"
	return self;
#line 1454 "key-event.c"
}

KkcKeyEvent*
kkc_key_event_new_from_x_event (guint keyval,
                                guint keycode,
                                KkcModifierType modifiers)
{
#line 202 "key-event.vala"
	return kkc_key_event_construct_from_x_event (KKC_TYPE_KEY_EVENT, keyval, keycode, modifiers);
#line 1464 "key-event.c"
}

/**
         * Create a key event from an X event.
         *
         * @param keyval an X keysym
         * @param keycode an X keycode
         * @param modifiers modifier mask
         *
         * @return a new KeyEvent
         */
KkcKeyEvent*
kkc_key_event_construct (GType object_type,
                         guint keyval,
                         guint keycode,
                         KkcModifierType modifiers)
{
	KkcKeyEvent * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 218 "key-event.vala"
	self = (KkcKeyEvent*) g_object_new (object_type, NULL);
#line 222 "key-event.vala"
	_tmp0_ = kkc_key_event_utils_keyval_name (keyval);
#line 222 "key-event.vala"
	_tmp1_ = _tmp0_;
#line 222 "key-event.vala"
	kkc_key_event_set_name (self, _tmp1_);
#line 222 "key-event.vala"
	_g_free0 (_tmp1_);
#line 223 "key-event.vala"
	kkc_key_event_set_unicode (self, kkc_key_event_utils_keyval_unicode (keyval));
#line 227 "key-event.vala"
	if (((guint) 0x21) <= keyval) {
#line 227 "key-event.vala"
		_tmp2_ = keyval < ((guint) 0x7F);
#line 1502 "key-event.c"
	} else {
#line 227 "key-event.vala"
		_tmp2_ = FALSE;
#line 1506 "key-event.c"
	}
#line 227 "key-event.vala"
	if (_tmp2_) {
#line 228 "key-event.vala"
		modifiers = modifiers & (~(KKC_MODIFIER_TYPE_SHIFT_MASK | KKC_MODIFIER_TYPE_MOD5_MASK));
#line 1512 "key-event.c"
	}
#line 230 "key-event.vala"
	kkc_key_event_set_keyval (self, keyval);
#line 231 "key-event.vala"
	kkc_key_event_set_keycode (self, keycode);
#line 232 "key-event.vala"
	kkc_key_event_set_modifiers (self, modifiers);
#line 218 "key-event.vala"
	return self;
#line 1522 "key-event.c"
}

KkcKeyEvent*
kkc_key_event_new (guint keyval,
                   guint keycode,
                   KkcModifierType modifiers)
{
#line 218 "key-event.vala"
	return kkc_key_event_construct (KKC_TYPE_KEY_EVENT, keyval, keycode, modifiers);
#line 1532 "key-event.c"
}

const gchar*
kkc_key_event_get_name (KkcKeyEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 58 "key-event.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "key-event.vala"
	_tmp0_ = self->priv->_name;
#line 58 "key-event.vala"
	result = _tmp0_;
#line 58 "key-event.vala"
	return result;
#line 1548 "key-event.c"
}

void
kkc_key_event_set_name (KkcKeyEvent* self,
                        const gchar* value)
{
	gchar* old_value;
#line 58 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 58 "key-event.vala"
	old_value = kkc_key_event_get_name (self);
#line 58 "key-event.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1562 "key-event.c"
		gchar* _tmp0_;
#line 58 "key-event.vala"
		_tmp0_ = g_strdup (value);
#line 58 "key-event.vala"
		_g_free0 (self->priv->_name);
#line 58 "key-event.vala"
		self->priv->_name = _tmp0_;
#line 58 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_NAME_PROPERTY]);
#line 1572 "key-event.c"
	}
}

gunichar
kkc_key_event_get_unicode (KkcKeyEvent* self)
{
	gunichar result;
#line 63 "key-event.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 63 "key-event.vala"
	result = self->priv->_unicode;
#line 63 "key-event.vala"
	return result;
#line 1586 "key-event.c"
}

void
kkc_key_event_set_unicode (KkcKeyEvent* self,
                           gunichar value)
{
	gunichar old_value;
#line 63 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 63 "key-event.vala"
	old_value = kkc_key_event_get_unicode (self);
#line 63 "key-event.vala"
	if (old_value != value) {
#line 63 "key-event.vala"
		self->priv->_unicode = value;
#line 63 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_UNICODE_PROPERTY]);
#line 1604 "key-event.c"
	}
}

guint
kkc_key_event_get_keyval (KkcKeyEvent* self)
{
	guint result;
#line 68 "key-event.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 68 "key-event.vala"
	result = self->priv->_keyval;
#line 68 "key-event.vala"
	return result;
#line 1618 "key-event.c"
}

void
kkc_key_event_set_keyval (KkcKeyEvent* self,
                          guint value)
{
	guint old_value;
#line 68 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 68 "key-event.vala"
	old_value = kkc_key_event_get_keyval (self);
#line 68 "key-event.vala"
	if (old_value != value) {
#line 68 "key-event.vala"
		self->priv->_keyval = value;
#line 68 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_KEYVAL_PROPERTY]);
#line 1636 "key-event.c"
	}
}

guint
kkc_key_event_get_keycode (KkcKeyEvent* self)
{
	guint result;
#line 73 "key-event.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 73 "key-event.vala"
	result = self->priv->_keycode;
#line 73 "key-event.vala"
	return result;
#line 1650 "key-event.c"
}

void
kkc_key_event_set_keycode (KkcKeyEvent* self,
                           guint value)
{
	guint old_value;
#line 73 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 73 "key-event.vala"
	old_value = kkc_key_event_get_keycode (self);
#line 73 "key-event.vala"
	if (old_value != value) {
#line 73 "key-event.vala"
		self->priv->_keycode = value;
#line 73 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_KEYCODE_PROPERTY]);
#line 1668 "key-event.c"
	}
}

KkcModifierType
kkc_key_event_get_modifiers (KkcKeyEvent* self)
{
	KkcModifierType result;
#line 78 "key-event.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 78 "key-event.vala"
	result = self->priv->_modifiers;
#line 78 "key-event.vala"
	return result;
#line 1682 "key-event.c"
}

void
kkc_key_event_set_modifiers (KkcKeyEvent* self,
                             KkcModifierType value)
{
	KkcModifierType old_value;
#line 78 "key-event.vala"
	g_return_if_fail (self != NULL);
#line 78 "key-event.vala"
	old_value = kkc_key_event_get_modifiers (self);
#line 78 "key-event.vala"
	if (old_value != value) {
#line 78 "key-event.vala"
		self->priv->_modifiers = value;
#line 78 "key-event.vala"
		g_object_notify_by_pspec ((GObject *) self, kkc_key_event_properties[KKC_KEY_EVENT_MODIFIERS_PROPERTY]);
#line 1700 "key-event.c"
	}
}

static void
kkc_key_event_class_init (KkcKeyEventClass * klass,
                          gpointer klass_data)
{
#line 54 "key-event.vala"
	kkc_key_event_parent_class = g_type_class_peek_parent (klass);
#line 54 "key-event.vala"
	g_type_class_adjust_private_offset (klass, &KkcKeyEvent_private_offset);
#line 54 "key-event.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_kkc_key_event_get_property;
#line 54 "key-event.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_kkc_key_event_set_property;
#line 54 "key-event.vala"
	G_OBJECT_CLASS (klass)->finalize = kkc_key_event_finalize;
#line 1718 "key-event.c"
	/**
	         * The base name of the KeyEvent.
	         */
#line 54 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_NAME_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1724 "key-event.c"
	/**
	         * The base unicode output of the KeyEvent.
	         */
#line 54 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_UNICODE_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_UNICODE_PROPERTY] = g_param_spec_uint ("unicode", "unicode", "unicode", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1730 "key-event.c"
	/**
	         * X keyval.
	         */
#line 54 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_KEYVAL_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_KEYVAL_PROPERTY] = g_param_spec_uint ("keyval", "keyval", "keyval", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1736 "key-event.c"
	/**
	         * X keycode.
	         */
#line 54 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_KEYCODE_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_KEYCODE_PROPERTY] = g_param_spec_uint ("keycode", "keycode", "keycode", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1742 "key-event.c"
	/**
	         * Modifier mask.
	         */
#line 54 "key-event.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KKC_KEY_EVENT_MODIFIERS_PROPERTY, kkc_key_event_properties[KKC_KEY_EVENT_MODIFIERS_PROPERTY] = g_param_spec_flags ("modifiers", "modifiers", "modifiers", KKC_TYPE_MODIFIER_TYPE, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1748 "key-event.c"
}

static void
kkc_key_event_instance_init (KkcKeyEvent * self,
                             gpointer klass)
{
#line 54 "key-event.vala"
	self->priv = kkc_key_event_get_instance_private (self);
#line 1757 "key-event.c"
}

static void
kkc_key_event_finalize (GObject * obj)
{
	KkcKeyEvent * self;
#line 54 "key-event.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
#line 58 "key-event.vala"
	_g_free0 (self->priv->_name);
#line 54 "key-event.vala"
	G_OBJECT_CLASS (kkc_key_event_parent_class)->finalize (obj);
#line 1770 "key-event.c"
}

/**
     * Object representing a key event.
     */
static GType
kkc_key_event_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KkcKeyEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_key_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcKeyEvent), 0, (GInstanceInitFunc) kkc_key_event_instance_init, NULL };
	GType kkc_key_event_type_id;
	kkc_key_event_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcKeyEvent", &g_define_type_info, 0);
	KkcKeyEvent_private_offset = g_type_add_instance_private (kkc_key_event_type_id, sizeof (KkcKeyEventPrivate));
	return kkc_key_event_type_id;
}

GType
kkc_key_event_get_type (void)
{
	static volatile gsize kkc_key_event_type_id__once = 0;
	if (g_once_init_enter (&kkc_key_event_type_id__once)) {
		GType kkc_key_event_type_id;
		kkc_key_event_type_id = kkc_key_event_get_type_once ();
		g_once_init_leave (&kkc_key_event_type_id__once, kkc_key_event_type_id);
	}
	return kkc_key_event_type_id__once;
}

static void
_vala_kkc_key_event_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
#line 54 "key-event.vala"
	switch (property_id) {
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_NAME_PROPERTY:
#line 54 "key-event.vala"
		g_value_set_string (value, kkc_key_event_get_name (self));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_UNICODE_PROPERTY:
#line 54 "key-event.vala"
		g_value_set_uint (value, kkc_key_event_get_unicode (self));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_KEYVAL_PROPERTY:
#line 54 "key-event.vala"
		g_value_set_uint (value, kkc_key_event_get_keyval (self));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_KEYCODE_PROPERTY:
#line 54 "key-event.vala"
		g_value_set_uint (value, kkc_key_event_get_keycode (self));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_MODIFIERS_PROPERTY:
#line 54 "key-event.vala"
		g_value_set_flags (value, kkc_key_event_get_modifiers (self));
#line 54 "key-event.vala"
		break;
#line 1838 "key-event.c"
		default:
#line 54 "key-event.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "key-event.vala"
		break;
#line 1844 "key-event.c"
	}
}

static void
_vala_kkc_key_event_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	KkcKeyEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KKC_TYPE_KEY_EVENT, KkcKeyEvent);
#line 54 "key-event.vala"
	switch (property_id) {
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_NAME_PROPERTY:
#line 54 "key-event.vala"
		kkc_key_event_set_name (self, g_value_get_string (value));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_UNICODE_PROPERTY:
#line 54 "key-event.vala"
		kkc_key_event_set_unicode (self, g_value_get_uint (value));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_KEYVAL_PROPERTY:
#line 54 "key-event.vala"
		kkc_key_event_set_keyval (self, g_value_get_uint (value));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_KEYCODE_PROPERTY:
#line 54 "key-event.vala"
		kkc_key_event_set_keycode (self, g_value_get_uint (value));
#line 54 "key-event.vala"
		break;
#line 54 "key-event.vala"
		case KKC_KEY_EVENT_MODIFIERS_PROPERTY:
#line 54 "key-event.vala"
		kkc_key_event_set_modifiers (self, g_value_get_flags (value));
#line 54 "key-event.vala"
		break;
#line 1888 "key-event.c"
		default:
#line 54 "key-event.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "key-event.vala"
		break;
#line 1894 "key-event.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

